/*
	Write by xempo Nov 2015
	Free under LGPL
*/

#include "tabwdg.h"

TabWdg::TabWdg(QWidget *p, int idx) : QWidget(p), index(idx)
{
}

void TabWdg::changddtt()
{
__params[index]=(settingCombo->count()-1) - settingCombo->currentItem();
settingLab->setText(QString::fromUtf8(dtfmt)+QDateTime::currentDateTime().toString(dtfmtlst.lstIndex(__params[index])));
}

void TabWdg::init(const char **chs, int tabw, int fntSz, int id)
{
	QFont fnt;
	if(ReadFont(fnt, id)==false)fnt=font();
	QLabel *fntLab=new QLabel(QString::fromUtf8(chs[1]/*prgfontChs*/), this);
	QLabel *szLab=new QLabel(QString::fromUtf8(chs[2]/*fntSzChs*/), this);
	fntLab->setAlignment(Qt::AlignCenter);
	szLab->setAlignment(Qt::AlignCenter);
	comboFont = new QComboBox( false, this );
	QFontDatabase db;
	comboFont->insertStringList( db.families() );
	comboFont->setCurrentText( fnt.family() );
	comboSize = new QComboBox( false, this );
	QValueList<int> sizes = db.standardSizes();
	QValueList<int>::Iterator it1 = sizes.begin();
	while( it1 != sizes.end() ){
		comboSize->insertItem( QString::number( *it1 ) );
		++it1;
		}
	comboSize->setCurrentText( QString::number( fnt.pointSize() ) );

	boldChk=new QCheckBox(QString::fromUtf8(chs[3]/*boldChs*/), this);
	italicChk=new QCheckBox(QString::fromUtf8(chs[4]/*italicChs*/), this);
	underlineChk=new QCheckBox(QString::fromUtf8(chs[5]/*underlineChs*/), this);
	boldChk->setChecked(fnt.bold());
	italicChk->setChecked(fnt.italic());
	underlineChk->setChecked(fnt.underline());
	fntLab->setGeometry(/*scaleRect(*/fntSz*2, 40, fntSz*4, fntSz*3/2 );
	comboFont->setGeometry(/*scaleRect(*/31+fntSz*4, 40, 210, fntSz*3/2 );
	szLab->setGeometry(fntSz*2, 80, fntSz*4, fntSz*3/2 );
	comboSize->setGeometry(31+fntSz*4, 80, fntSz*6, fntSz*3/2 );
	boldChk->setGeometry(fntSz*27/8, 126, fntSz*6, fntSz*3/2 );
	italicChk->setGeometry(fntSz*27/8, 126+fntSz*3/2, fntSz*6, fntSz*3/2 );
	underlineChk->setGeometry(fntSz*27/8, 126+fntSz*3, fntSz*6, fntSz*3/2 );
	QFrame *line=new QFrame(this);
	line->setFrameStyle( QFrame::HLine | QFrame::Sunken );
	line->setGeometry(fntSz, 126+fntSz*11/2, tabw-2*fntSz, 6);
	dtfmt=chs[6];
	settingLab=new QLabel(QString::fromUtf8(dtfmt)+QDateTime::currentDateTime().toString(dtfmtlst.lstIndex(__params[index])), this);
	settingCombo=creatCombo( false, this, "dtfmt", p_dtfmtlst, -1 );
	settingCombo->setCurrentItem( (settingCombo->count()-1) - __params[index]);
	connect(settingCombo, sigactIdx, topLevelWidget(), SLOT(dtfmtSel()));
	int left=fntSz*2, posH=126+fntSz*7;
	settingLab->setGeometry(left, posH, tabw-fntSz*5/2, fntSz*17/10);
	settingCombo->setGeometry(left, posH+fntSz*2, tabw-fntSz*4, fntSz*17/10);
	((QTabWidget *)parentWidget())->addTab(this, QString::fromUtf8(chs[0]));
}

