/*
	Write & edit by Linjianghua(xempo)
	Copyright 2005 Linjianghua(xempo), 2014, 2015
	Reserve all rights of this file
*/

#define	bool	int
/* use gcc, not c++ */

#include "readfile.c"

#include <unistd.h>
#include <time.h>
#include <sys/stat.h>
#define  stricmp  strcasecmp

#include "memstr.c"
#include "strcut.c"
#include "fmtvalue.c"
#include "remzx.c"

char *divData(char *chs)
{
  int i;
  for(i=0; chs[i]!='='&&chs[i]; i++);
  if(chs[i])chs[i++]=0;
  else return NULL;
  return chs+i;
}

void namext(char *buff, const char *name, const char *ext, const char *dst)
{
 char *ptr;
  if(dst){
	int L=strlen(dst);
	strcpy(buff, dst);
	ptr=strrchr(name, DIV_CH);
	if(ptr){
		if(dst[L-1]=='/')L--;
		strcpy(buff+L, ptr);
		}
	else {
		buff[L++]='/';
		strcpy(buff+L, name);
		}
	}
  else strcpy(buff,name);
  ptr=strrchr(buff,'.');
  if(ptr)strcpy(ptr,ext);
  else strcat(buff,ext);
  if( (ptr=strrchr(buff, '/')) )
	switch(ptr[1]){
	case '1' :
	case '2' :
	case '3' : strcut(ptr+1, 1);
	}
}

static const char fext[2][5]={ ".h", ".fsd" },
usageChs[]="Translate file creator\n\
Usage : trfc filename |[--const |--noext] |[--oldcomp] |[-d target-dir] |[-o target-file]\n\
\tCreate C/C++ var define precompile by text-file\n\
\t--const   create file have extern with \"const\"\n\
\t--noext   create a C/C++ precompile no \"extern\"\
\t--oldcomp   compact old text style\n\
\t\"-d\" is specied dir for out\n\
\t\"-o\" is specied file for out\n";

#define  mu1  3
#define  mu2  2
static const char *pms_mode[mu1]={ "--const", "--noext", "--oldcomp" }, *mu2chs[mu2]={"-d", "-o"};

int main(int argc, char **argv)
{
if( argc > 1 ){
 unsigned int len;
 int b, cnt, d_len, p_len, lines;
 FILE *fp_pts, *fp_fsd;
 static const char WT[]="wt";
 char *p_d, *pt,  chr, *buffers, *pRt, *charsNam, FileName[2000];
/*------------------------------------------------------------------*/
 int i, j, idx=0, pmc=0, mu1val[mu1], *pmpos;
 struct stat st;
 time_t tm;
 const char  *dstdir=NULL, *src=NULL, *dstfile=NULL;
 pmpos=(int *)malloc(sizeof(int)*(argc-1));
 for(i=0; i<argc-1; i++)pmpos[i]=-1;
 
 for(i=0; i<mu1; i++){ mu1val[i]=-1;
     for(j=1; j<argc; j++)if(stricmp(pms_mode[i],argv[j])==0){
	if( i==1 && mu1val[0]!=-1){
		printf("%s can't use with %s\n", pms_mode[1], pms_mode[0]);
		return -1;
		}
	idx=i+1;	mu1val[i]=j; // pos
	pmpos[pmc++]=j;
	}
 }

 for(j=0; j<mu2; j++)
  for(i=1; i<argc; i++)if(stricmp(mu2chs[j], argv[i])==0){
	switch(j){
	case 0 : for(b=0; b<mu1; b++)if(mu1val[b]==i+1)goto _jmp_;
		if(i+1>=argc ){
		_jmp_: if(dstdir==NULL){
			printf("A dir must follow \"-d\" for out !\n");
			pmpos[pmc++]=i;
		}
		continue;
		}
		if(stat(argv[i+1], &st) || !S_ISDIR(st.st_mode) )printf("\"-d\" specied \"%s\" is not existed dir !\n", argv[i+1]);
		else if(dstdir)printf("Out dir has specied \"%s\", \"%s\" not be use !\n", dstdir, argv[i+1]);
	 		else dstdir=argv[i+1];
		break;
	case 1 : if(dstfile)printf("Out file has specied \"%s\", \"%s\" not be use !\n", dstfile, argv[i+1]);
		  else dstfile=argv[i+1];
	}
	pmpos[pmc++]=i;		pmpos[pmc++]=++i;
	}

 for(i=1; i<argc; i++)if(*argv[i]!='-'){
	if(argv[i]!=dstdir)
		if(stat(argv[i], &st)==0 && !S_ISDIR(st.st_mode) ){
		src=argv[i];
		pmpos[pmc++]=i;
		break;
		}
	}

 if(pmc<argc-1)for(i=1; i<argc; i++){
	for(j=0; j<pmc && pmpos[j]!=i; j++);
	if(j>=pmc)printf("** Warn ! \"%s\" is not use param\n", argv[i]);
	}

 if(src==NULL){ puts("No source file input\n");  goto errpm; }

 p_d=strchr(*argv, DIV_CH);
 if(p_d){	*p_d=0;
	_ProgPath=*argv;
	}
//--------------------------------------------------------

 buffers=ReadFile(src,&len);
 if(buffers){
  if( (len=remzx(buffers, NULL))<1 || mu1val[2]!=-1 && (len=remzx(buffers, "///**/")+1)<2  ){
	puts("Not any thing !"); return 0;
	}
   if(dstfile==NULL)namext(FileName, src, fext[0], dstdir ? dstdir : NULL );
   fp_pts=fopen(dstfile ? dstfile : FileName, WT);
   if(fp_pts==NULL){
	perror(FileName);
	return -1;
	}
   if(dstfile==NULL)namext(FileName, src, fext[1], dstdir ? dstdir : NULL);
   fp_fsd=fopen(dstfile ? dstfile : FileName, WT);
   if(fp_fsd==NULL){
	perror(FileName);
	return -1;
	}
   time(&tm);
   fprintf(fp_pts, "/*\n\tInternation tranlate !\n\tFree under LGPL\n\t%s", ctime(&tm) );
//	p_d=asctime(localtime(&tm));

   charsNam=strrchr(FileName, '.');
   if(charsNam)*charsNam=0;
   charsNam=strrchr(FileName,'/');
   if(charsNam)charsNam++;
   else charsNam=(char *)FileName;
   fprintf(fp_pts,  "*/\n\n#ifndef\t%s_chars\n#define\t%s_chars\n\n", charsNam, charsNam);
   if(mu1val[1]==-1)
	fprintf(fp_pts, "extern %s char **_%s_;\n\n", mu1val[0]!=-1 ? "const" : "", charsNam);

/*===============================================*/
    len=strlen(buffers)+1;	cnt=0; lines=0;
    while(*buffers==32||*buffers==9)buffers++;
    pt=buffers;
    for(i=0;i<len;i++){ chr=buffers[i];
      if(chr==10||chr==0){
	buffers[i]=0;	lines++;
	p_d=divData(pt);
	if(p_d==NULL/*|| (pt[0]=='/'&&pt[1]=='/')*/)goto _skp_;
	p_len=fmtvalue(pt, 0);
	d_len=fmtvalue(p_d, 1);
//	printf("%s,%s", pt, p_d);

	if(pt!=buffers){
	    pRt=memstr(buffers, b, pt, p_len, 3);
	    if(pRt && pRt[-1]==0 && pRt[p_len]==0 ){
		printf(" ** Fail in %s : %d !\nmult define : %s\n", src, lines, pt);
		return -1;
		}
	}

	fprintf(fp_pts, "#define\t%s\t\t_%s_[%d]\n", pt, charsNam, cnt);
	fprintf(fp_pts, "#define  Int_%s %d\n", pt, cnt++);

	for(j=0; j<d_len ; j++)
		if(p_d[j]=='\\'&&p_d[1+j]=='n'){
			p_d[j]=10;
			strcut(p_d+j+1,1);
			d_len--;
			}
	fwrite(p_d, d_len+1, 1, fp_fsd);
	_skp_: b=i+1;	pt=buffers+b;
    	}   
    }
    fprintf(fp_pts, "\n#define\t\t%s_cnt\t\t%d\n\n#endif\n\n",charsNam, cnt);
    fclose(fp_fsd);    fclose(fp_pts);
    return 0; /* for make.exe */
    }
/* Null */
 }
else errpm: puts(usageChs);
return -1; /* for make.exe */
}
