/*
  Designed by Linjianghua(Xempo) 2004-2006, 2012
  Free under LGPL
*/

#ifndef		___ORD_
#define		___ORD_
#include "orkern.h"

#define	DIR_DEL			512+(1<<4)
#define	DIR_REN		512+(2<<4)
#define	DIR_WRITE		512+(3<<4)
#define	DIR_READ		512+(4<<4)

#define	DIR_RESCUE		512+(5<<4)
#define	DIR_FCU_POS		512+(7<<4)
#define	DIR_FCU_BLANK		512+(8<<4)
#define	DIR_BROW		512+(9<<4)

#define Ch_Dir			8192
#define DECT_OVER		16384

extern const char rootchs[];

extern int nameCRC(const char *dirnam); /* Case */

extern int getLenght(__ORD *);

extern void (*pGetPdExt)(__ORD *dir);

#define  ORDinit(dirbuf)	memset(dirbuf, 0, sizeof(__ORD) )

#define  setCurORD(dir)  (dir->lib->CurDir=dir)

#define  pd_param_cnt  5
extern const un_Int PPS[pd_param_cnt];

extern void setPdPara(__ORD *dir, const un_Int *pms);

extern void setZero(__ORD *dir, int s);

__BEGIN_DECLS

extern __ORD *ORDparent(__ORD *dir, char *pth, char **fixname);

extern __ORD *ORDalloc();

extern __ORD *ORDread(__ORL *lib, __ORD *dirbuf, DirFCU *du, dskadr_t adr, BOOL far_use);/* if far_use, generic use ORDclose(dir, 2); */

/*	*para=0; Format 
	para[1]=10;	n_stat_FCT   10 
	para[2]=4;	dir_stat_FCT  4 
	para[3]=dau, ignore = 1
	para[4]=1|2;  mode: RW  */
extern __ORD *ORDcreat(__ORD *odir, char *pth, const un_Int *pms);

extern __ORD *ORDopen(__ORD *cdir, const char *pth, int _msg);
#define	DirOpen(dir,pth)	ORDopen(dir, pth, DIR_READ)

extern void ORDclose(__ORD *dir, int mode);
__END_DECLS

#define  isSameORD(dir1, dir2) (dir1->Own_FCU_Addr==dir2->Own_FCU_Addr)

#endif

