/*
  Designed by Linjianghua(Xempo) 2005-06,2008-2010, 2012
  Free under LGPL
*/

#include "ortime.h"
#include "ordir.h"
#include "jxswitch.h"

#include "infor.h"
#include "init.h"

extern char *OutBuf;

static __ORD *ls_dir;

const char *browsMode[BrowsModeCnt]={ "-n", "-d", "-i", "-t", "-p" },
	*_browsMode[BrowsModeCnt]={ "--num", "--dir", "--include", "--total", "--page" };

int pagemore;
static int pageMore(int pg)
{
static int ScrLk;
if(getMsg==NULL&&pagemore){
  if(ScrLk++>pg){
	char bu[8];
	puts(" More, press \'q\' to end");
	ScrLk=0;
	fgets(bu,7,stdin);
/*	puts(SPC);*/
	if( (*bu|32)=='q' )return 1;
	}
}
return 0;
}

static BOOL showFCU(__ORD *dir, BYTE *fcu, BOOL Q_mode)
{/* Q_mode normal is chmode without -m:?, ls [nmb], numb [nmb],  */
int nmb=isZero(dir->Format) ? dir->NumbForZero++ : *(int *)(fcu+FCU_NumPos);
if((*fcu&3)==1 && (Q_mode||(fcu[1]&ORL_MH)==0) ){
	int j;
	char buf[58], modebuf[8];
	DLong Len;
	if( (Len=*fcu >> 2 )==0 )
		getSize(dir, fcu, Len)
	buf[56]=0;
	for(j=1;j<37;j++)buf[j]=0;
	sprintf(buf, "%d", nmb);
	paraExpre(fcu[1],modebuf, "rwhoABGL");
	strcpy(buf+17, modebuf);
	sprintf(buf+24, "%llu", Len);
	strcpy(buf+36,(char *)ORasctim(FCU_GetDate(fcu) ) );
	for(j=1;j<36;j++)if(buf[j]==0)buf[j]=32;
	msgShow(buf);
	if( pageMore(21) )return False;
	}
return True;
}

static int n_list(__ORD *dir,BYTE *fct)
{
  int i;
  for(i=0; i<dir->Num_FCUs_Block; i++,fct+=dir->Num_FCU_Len )
	if(showFCU(dir,fct,False)==False)return 0;
  return 1;
}

static const char modeChs[]="rwho", pdfmt[]="zt";
static void showORD(__ORD *dir, char *pth)
{
  char buff[8], buff2[8], shw[300];
  paraExpre(dir->mode, buff, modeChs);
  paraExpre(dir->Format, buff2, pdfmt);
  sprintf(shw, dirfmt, pth, buff, buff2, dir->selfnumbs,
	dir->selfdirs,dir->selfsize,ORasctim(dir->datebuf));
//  len=sprintf(shw, "  %s %s NumStyle:%s Numb=%d ",pth, buff, buff2, dir->selfnumbs);
//	sprintf(shw+len, "[Dir=%d] [sz=%lld]  %s",dir->selfdirs,dir->selfsize,ORasctim(dir->datebuf));
  msgShow(shw);
}

static int d_list(__ORD *pdir,__ORD *dir)
{
if( (dir->mode&ORL_MH)==0 /*canAccess(dir->mode)*/ ){
  char *pt=ORDpath(dir,/*dir->lib->CurDir*/ ls_dir, 1);
  int i, dirLoops=1;
  for(i=0; pt[i]; i++)if(pt[i]=='/')dirLoops++;
  if( dirLoops > 0 ){
	char buf[dirLoops*2+1], *tmp;
	memset(buf, 32, dirLoops*2); 
	buf[dirLoops*2]=0;
	tmp=catstr(buf, pt, 0);
	free(pt);
	pt=tmp;
	}
  showORD(dir, pt);
  free(pt);
  pageMore( 21 );
}
return 1;
}

int getBM(int *brwVal)
{
int i, msg=0;
pagemore=0;
for(i=0; i<BrowsModeCnt; i++)
    if(brwVal[i])
	switch(i){
	case 3 : msg=7;
		break;
	case 4 : pagemore=True;
		break;
	default : msg|=1<<i;
	}
return msg;
}

void ORDlist(__ORD *dir0, int n, char **pm, int nCom)
{
int numb;
BOOL isNum;
BYTE *stat;
__ORD *dir;
int i, ocn, msg, brwVal[BrowsModeCnt];
memset(brwVal, 0, sizeof(int)*BrowsModeCnt);
ProcOpt optBrows={	BrowsModeCnt,	browsMode, _browsMode,	brwVal,	0, NULL, 0	};
arglists *lst=procParas(n, pm, &optBrows, NULL);
msg=getBM(brwVal);
i=0;
ocn=lst->argc;
if(ocn==0){
	dir=dir0;
	dir->otherOpen++;
	goto _jmp_;
	}
while(i<ocn){
  isNum=adjNumb((char *)lst->argv[i]);
  dir=DirOpen(dir0, isNum ? divPath((char *)lst->argv[i],&numb) : (char *)lst->argv[i]);
  if(idxdscpt<0x7ffd){ reportBug(); goto _nx_; }
  if(isNum){
    switch(nCom){
    case ORL_numb :
    case ORL_ls : if( (stat=seekFCU(dir,numb, NULL,NUMB_BROW))!=NULL ){
		  showFCU(dir, stat, True);
		  if(nCom==ORL_numb){
			int j, Len=0, tlen=0;
			BYTE *ptr;
			for(j=0; j<dir->DAUC; j++){
			  ptr=pFcuDauPos( dir, stat, j )+sizeof(dskadr_t);
			  Len=sprintf(OutBuf+Len, "  DAU%d:  prelen=%d\t\tlen=%d\n", j, *(int *)ptr, *(int *)(ptr+sizeof(int)) );
			  tlen+=Len;
			}
			OutBuf[tlen-1]=0;
			msgShow(OutBuf);
		  }
		  free(stat);
		}
		else reportBug();
	break;
    default : ORtips(IsNumb_14, 0);
	showUsage(nCom);
    }
  }
  else _jmp_: if(nCom==ORL_ls){
		if((msg&3)==0)msg|=3;
		ORDinfo(dir, OutBuf);
		msgShow(OutBuf);
		lock=1;
		ls_dir=dir;
		ORDbrowth(dir, msg, n_list, d_list);
	}
ORDclose(dir,1);
_nx_: i++;
}
argsFree(lst);
}

void ORDinfo(__ORD *dir,char *buff)
{
if(dir){
char buf[8], buf2[8];
paraExpre(dir->mode,buf, modeChs);
paraExpre(dir->Format, buf2, pdfmt);
sprintf(buff, dirfmt,
	dir->name, buf, buf2,
	dir->selfnumbs, dir->selfdirs, dir->selfsize,
	ORasctim(dir->datebuf) );
}
}

void ORDinfors(__ORD *dir, char *buf, int s)
{
     int L;
     char  *pt, typebuf[8], modebuf[8];
     *buf=0;
     pt=ORDpath(dir,NULL,0);
     paraExpre(dir->mode, modebuf, "rwho");
     paraExpre(dir->Format, typebuf, "zt");
     L=sprintf(buf, rt_msg[5], (pt? pt : rootchs), ORasctim(dir->datebuf),
	dir->selfsize,dir->Num_FCUs_Block,dir->selfnumbs,
	dir->Dir_FCUs_Block,dir->selfdirs,
	typebuf, dir->DAUC,
	modebuf, modeToStr(dir->mode));
     if(pt)free(pt);
     if(s){
	const char *ModeScpt=GetHB(38);
	strcpy(buf+L, ModeScpt);
	free((void *)ModeScpt);
	}
     if(s<2)/* popwdg for porperties */
	msgShow(buf);
}
