/*
	Write & edit by Linjianghua 2005-06,2008-2010, 2014
	Free under LGPL
*/

#include "normal.h"
#include "ortime.h"
#include "ordir.h"
#include "dirext.h"
#include "script.h"
#include "shellcom.h"
#include "write.h"
#include "conspace.h"
#include "input.h"
#include "dirloop.h"
#include "fculoop.h"
#include "infor.h"
#include "read.h"
#include "stdfun.h"
#include "jxswitch.h"
#include "init.h"

const int RTself=1;
int main(int argc,char **argv)
{
  int i, rt=0 /* for make */;
  __ORL *lib=NULL;
  char *ptr;
  popMsg=putMsg;  	msgShow=puts;
  PrnTxt=outTxt;
  if(argc<2)printf("\033[2J\033[1;1H");
  printf("\t\033[34m%s\033[0m\n", orlVer);
  i=init(&argc, argv, "--lang,--help,-h");
  if(conVal>0)ORtips(Readme_31, 0);
  switch(i){
  case ini_first : // first
	if(conVal==0)ORtips(Readme_31, 0);
  case ini_norm : {
	time_t tm;
	time(&tm);
	sprintf(InpBuf, "OpenRose init: %s", ctime(&tm) );
	}
	runLog(InpBuf);
	if((ptr=sysIdRead(*workspace, CONFIG_ID))!=NULL){ /* orlconf */
	    setCfgVal(ptr);
	    free(ptr);
	  }
	  if(argc>1){
		for(i=1; i<argc; i++)
			lib=comRun(lib, argv[i], 0, NULL );
	  }
	  else if((ptr=sysIdRead(*workspace, AUTORUN_ID))!=NULL){/* orlinit */
		fmtvalue(ptr, 1); /* rem "" sybm for UseFile */
		lib=ORLscript(NULL, ptr, 0, NULL);
		free(ptr);
		}

  while(CommNumb!=ORL_exit){
   if(CommNumb==ORL_quit /* extern runing-msg */){
	rt=-1;	goto _ex_;
	}
    if(lib){
      char *pth=ORDpath(lib->CurDir,NULL,0);
      printf( "%s]", pth);
      free(pth);
    }
    else printf(". ");
    *InpBuf=0;
     inCon(InpBuf, 2047);
     runinginfo=0;     CommNumb=-20; OverWrite=0;
     lib=comRun(lib, InpBuf, 0, NULL ); /* set CommNumb */
  }
_ex_: for(i=LASTSPACE;i>-1;i--)if(workspace[i])ORLreleas(workspace[i], NULL);
 break;
 case ini_notorl : PrnTxt(1,4,orlKern);
 case ini_nocom : 
 case ini_notinst : printf(pInfo, rtfn);
 }
return rt;  /* for make */
}
