/*
  Designed by Linjianghua(Xempo) 2004-2006, 2012, 2014
  Free under LGPL
*/

#include "stdfun.h"
#include "dirext.h"
#include "script.h"
#include "infor.h"
#include "dirloop.c"


char *ORDpath(__ORD *dir,__ORD *lmt,int msg)
{/* msg: 0 lmt only opening-dir; 1 limit all sub, 2 include itself */
char *pth, *ptr;
__ORD dirbuf, *dir1;
dskadr_t adr;
if(lmt&&lmt->own_adr==dir->own_adr&&msg)return strdup(dir->name);
adr=dir->parent_adr;
switch(adr){
case 0 : return msg ? strdup(dir->name) : catstr(rootchs, dir->name, 0);
case 1 : return strdup(rootchs);
}
pth=strdup(dir->name);
do{
   if(lmt&&lmt->own_adr==adr){
	if(msg==1)break;
	dir1=lmt;
	}
   else dir1=ORDread(dir->lib,&dirbuf,NULL,adr, False);
   ptr=pth;
   pth=catstr(dir1->name,pth, '/');
   free(ptr);
   if(msg==2&&dir1==lmt)break;
   adr=dir1->parent_adr;
}while( adr>1 );

if(adr<2&&msg==0){
	ptr=catstr(rootchs,pth,'/');	free(pth);
	return ptr;
	}
return pth;
}

BOOL ORDchang(__ORL *lib, char *dirname,int sel)
{/* if use rt=False and use return rt, it would more large mem for use */
__ORD *dir1;
if(dirname==NULL)return True;
if(dirname[1]==0)
  switch(dirname[0]){
  case '*' : 
	if(diguei && isRS){
		if(lib->bakdir_adr){
			__ORD *tmp=ORDalloc();
			dir1=ORDread(lib, tmp, NULL, lib->bakdir_adr, True);
			if(dir1!=tmp)free(tmp);
		}
		else dir1=(__ORD *)lib;
		goto _jmp_;
	}
  case '.' : return True;
  case '/' :
  case '\\' : lib->CurDir=(__ORD *)lib;
	return True;
  }

dir1=DirOpen(lib->CurDir,dirname);
if(idxdscpt>0x7ffd){
_jmp_:if(dir1!=lib->CurDir){
	lib->bakdir_adr=lib->CurDir->own_adr;
	ORDclose(lib->CurDir,2);
	lib->CurDir=dir1;
	lib->mdf|=OnlyChDir; /* (128)not last mdf, no chtime */
	return True;
	}
	if(sel>0)return True;
}
else reportBug();
return False;
}

#include "osdir.c"
