/*
	write & edit by LinJiangHua(xempo)
	Free undef LGPL
*/

#ifndef  copy_def
#define  copy_def

#include <qthread.h>
#include "infowidget.h"
class Filesan;

enum normToSymRlt { OverCvtFile, OverSymPoint,  Exist_Sym_Skip,	Exist_Sym_Cancel,
	AllOverCvtFile, AllOverSymPoint, Exist_Sym_AllSkip };

enum delCvtSymToDirRlt { SymOver, SymNo, SymCancel, SymAllOver, SymAllNo };

enum copyOverRlt { SureCopy, SkipCopy, CancelCopy, AllCopy, AutoSkipCopy };

enum overFileAsDirRlt { OF_Yes, OF_No, OF_AllYes, OF_AllNo, OF_Cancel };

#define	 SYM_EXIST		17		
// above is sys errno


enum fileCopyRlt { cp_create=0, cp_overWrite=1, cp_noNeed=2,//没有必要的
	cp_newDir_errOut=128,
	opera_cancel=-1, cp_no=-2,
	cp_ignoreThrow=-3,	// 全忽略这个流
	cp_ignoreStat=-4,		// 全忽略这种情
	opera_error=-5,		// 包括没有磁盘空间
	dir_no_exe=-6
};

#define  is_dev(m)  (S_ISCHR(m) || S_ISBLK(m)|| S_ISFIFO(m) || S_ISSOCK(m))

typedef struct {
// QWidget *wdg;
const char *fn;
int hold, ret;
}del_params;

typedef struct {
char *src, *dst;
}move_params;

class CopyThread {
public :
CopyThread(QWidget *wdg, Filesan *f, FastBlock &s, const char *d, int msg);
~CopyThread();

void countSize(int msg);

QListViewItem *cell() const
{ return it; }

void releaseCell()
{
if(it)delete it;
}

Filesan *getFilesor() const
{ return fs; }

int getTag() const
{ return runCp; }

void setTag(int m){ runCp=m; }

void inCpPanel();

QWidget *getWdg() const
{ return wdg; }

void run();

private :
Filesan *fs;
QWidget *wdg;
QWidget *ptWdg();
QListViewItem *it;
FastBlock srcLst;
const char *_dst;
QTextCodec *codec;
void sizeCount(unsigned int len);
int adjustCopy(const char *chs, int *errnos, int id);
int fileCopy(int cmd, const char *s, const char *d);
int procDir(int Msg, const char *fdirnam, const char *dst);
int SymLink(const char *src, const char *dst);
void safeFreshData(const char *src, const char*dst);

int cp_postInfoWidget(const char *dst, int id, const char *cap=NULL);
void cp_posterrInfo(const char *txt, const char *cap);

int cpPreCount, CopyTag, SymCvtDir, ExistedSymlnk, OverFileAsDir,
	s_errorback[128], d_errorback[128];
bool cp_IsDir, mv2cp;

// --- during -----
const char *cursrc, *curdst;
unsigned long szM, size;
int isPop, cpMode, cpCnt, // count files
	cpDone, //  use as dirs count when COUNT_SIZE
#define  dirsCnt  cpDone
	runCp; // -1 send stop-sig; -2 have end

time_t th_take, retm;
unsigned long long tsz, csz; // persen %
QStringList cpInfoList;
};

extern QStringList copyInfoList;

extern void logRecorde(QStringList &msgList, const char *txt);

extern void saveLog(const char *logNam, QStringList &msgList);

extern QPtrList <CopyThread> copy_thr;

struct cpparam {
CopyThread *cpthr;
int idx;
};

#endif
