<html>
<head>
<style> 
 .fun-org { font-family: "DejaVu Serif";
	  font-size:12pt;
	  font-style: "oblique";
	}
 .cpp {
	font-family: "DejaVu Serif";
	font-size:12pt;
	font-weight:600;
	color: #248c30;
	}
  .orlLib {
	font-family:"DejaVu Serif";
	font-size:12pt;
	font-weight:600;
	color: #901010;
	}
  .orlDir {
	font-family:"DejaVu Serif";
	font-size:12pt;
	font-weight:600;
	color: #24308c;
	}
  .defExt {
	font-family:"DejaVu Serif";
	font-size:12pt;
	font-weight:600;
	color: #105010;
	}
</style>
</head>
<body bgcolor=#ebebeb>
<pre>
<a class="fun-org"><span class=defExt>extern</span> <span class=fspLib>__ORL</span> *ORLopen(const char *filenam, int msg)</a>
打開一個ORL文件，如果成功則返回ORL指針，否則是null，具體錯誤查看idxdscpt。
msg是一個位合成值，含2個意義：DectName(512)和FastBuf(1024)，一般在穩定運行中使用DectName|FastBuf。

<a name="_ORLclose_" class="fun-org"><span class=defExt>extern</span> int ORLclose(<span class=fspLib>__ORL</span> *lib, <span class=fspLib>__ORL</span>* (*Compr)(<span class=fspLib>__ORL</span> *,char *,int))</a>
關閉ORL文件，Compr是壓縮函數，用於自動偵測壓縮，可以是置空，此時沒有自動壓縮，
例如：ORLClose(ORL,NULL);

<a name="_ORLcreat_" class="fun-org"><span class=defExt>extern</span> <span class=fspLib>__ORL</span> *ORLcreat(char *fname,unshort *lst)</a>
產生一個ORL文件，lst讓用戶設定根目錄的屬性：具體如ORDcreat中的params，但此處多了2個參數，一個為zcache-size，一個為是否有緩沖區。
lst可以是NULL，表示使用默認。

<a name="_ORLalloc_" class="fun-org"><span class=defExt>extern</span> <span class=fspLib>__ORL</span> *ORLalloc(void)</a>
申請一個ORL空間, 并將空間初始化置0。

<a name="_ORDopen_" class="fun-org"><span class=defExt>extern</span> <span class=fspDir>__ORD</span> *ORDopen(<span class=fspDir>__ORD</span> *pdir,char *pth)</a>
打開一個目錄，pdir是打開了的目錄，一般用於pth的相對路徑。

<a name="_ORDclose_" class="fun-org"><span class=defExt>extern</span> int ORDclose(<span class=fspDir>__ORD</span> *dir, int mode))</a>
關閉目錄，dir是要關閉的目錄，mode=0表示絕對關閉，否則關閉一層（次，可能有多次打開）。

<a name="_ORDcreat_" class="fun-org"><span class=defExt>extern</span> <span class=fspDir>__ORD</span> *ORDcreat(<span class=fspDIr>__ORD</span> *dir, char *pth, const un_Int *paras)</a>
paras[0]：/* 格式，默認Format=0  */
paras[1]：/* 號碼預分配個數，默認n_stat_FCT=10 */
paras[2]：/* 目錄預分配個數，默認dir_stat_FCT=4  */
paras[3]：/*  DAU個數，默認=1 */
paras[4]：/* mode: RW (1|2) */
paras可以是NULL，表示使用默認。

<a name="_ORDread_" class="fun-org"><span class=defExt>extern</span> <span class=fspDir>__ORD</span> *ORDread(<span class=fspLib>__ORL</span> *lib,<span class=fspDir>__ORD</span> *dirbuf,DirStat *du,long adr)</a>
讀入目錄, 返回目錄指針。adr是目錄的磁槃地址, dirbuf是傳入的存儲緩沖,
du是根據名字查找到的目錄stat。

<a name="_ORDalloc_" class="fun-org"><span class=defExt>extern</span> <span class=fspDir>__ORD</span> *ORDalloc(void)</a>
申請一個目錄空間并初始化空間。

<a name="_NumRead_" class="fun-org"><span class=defExt>extern</span> BYTE *NumRead(<span class=fspDir>__ORD</span> *dir,long numb,MAU *send,int n)</a>
讀取一個號碼的內容, n指有多少個DAU, 可以少於實際數, send是承載取出資料的結搆體。

<a name="_NumWrite_" class="fun-org"><span class=defExt>extern</span> void NumWrite(<span class=fspDir>__ORD</span> *dir,long numb,MAU *send,int n)</a>
寫入一個號碼的內容, n指有多少個DAU, 可以少於實際數, send是承載寫入資料的結搆體。

<a name="_writeInit_" class="fun-org"><span class=defExt>extern</span> BYTE *writeInit(<span class=fspDir>__ORD</span> *dir,long numb,MAU *send,int n)</a>
寫入一個資料的初始化。返回stat的指針，用於WriteStat的資料最終寫入。
n指有多少個DAU, 可以少於實際數, send是承載寫入資料的結搆體。

<a name="_writeStat_" class="fun-org"><span class=defExt>extern</span> void writeStat(<span class=fspDir>__ORD</span> *dir,BYTE *InitedStat,MAU *send,int n)</a>
資料的最終寫入。

<a name="_sysIdRead_" class="fun-org"><span class=defExt>extern</span> char *sysIdRead(<span class=fspLib>__ORL</span> *lib, int numb)</a>
讀取特定Id。

<a name="_sysIdWrite_" class="fun-org"><span class=defExt>extern</span> void sysIdWrite(<span class=fspLib>__ORL</span> *lib, int numb, MAU *mau)</a>
寫入特定Id。

<a name="_writeDAU_" class="fun-org"><span class=defExt>extern</span> void writeDAU(<span class=fspDir>__ORD</span> *dir, BYTE *stat, MAU *send, int sw )</a>
寫入一個號碼的一個DAU, stat是號碼的狀況, 通過ReadStat查找得到。
sw是目錄(dir)下的號碼的樣式。

<a name="_readDAU_" class="fun-org"><span class=defExt>extern</span> char *readDAU(<span class=fspDir>__ORD</span> *dir,BYTE *stat,MAU *send,int sw)</a>
讀取一個號碼的一個DAU, stat是號碼的狀況, 通過ReadStat查找得到。
sw是目錄(dir)下的號碼的樣式。

<a name="_readStat_" class="fun-org"><span class=defExt>extern</span> void readStat(<span class=fspDir>__ORD</span> *dir,BYTE *stat,MAU *send,int n)</a>
根據stat讀取一個號碼。n指有多少個DAU, 可以少於實際數, send是承載取出資料的結搆體。

<a name="_statSeek_" class="fun-org"><span class=defExt>extern</span> BYTE *statSeek(<span class=fspDir>__ORD</span> *dir,long numb,char *dirnam,int flg)</a>
查找一個符合要求的stat, dirnam為NULL時為查找號碼, 否則是目錄。
<a class="cpp">#define </a> NumSeek(dir,numb,flg) statSeek(dir,numb,NULL,flg)
<a class="cpp">#define </a> ORDseek(dir,dirnam,flg) (DirStat *)statSeek(dir,0,dirnam,flg)

<a name="_putMsg_" class="fun-org"><span class=defExt>extern</span> int putMsg(const char *txt, const char *cap, int msg, void *pt)</a>

<a name="_runLog_" class="fun-org"><span class=defExt>extern</span> void runLog(const char *chs)</a>

<a name="_errInfo_" class="fun-org"><span class=defExt>extern</span> void errInfo(int idx, const char *pm)</a>

<a name="_ORLtips_" class="fun-org"><span class=defExt>extern</span> int ORLtips(int idx,int msg)</a>
/* msg>0 Warn( ** ), &2(1bit) is Queck */

<a name="_defaultHB_" class="fun-org"><span class=defExt>extern</span> void defaultHB(int idx)</a>

<a name="_reportBug_" class="fun-org"><a class="cpp">#define</a> reportBug()    defaultHB(28)

<a name="_indexUsage_" class="fun-org"><span class=defExt>extern</span> int indexUsage(int nCom, const _Int *coms)</a>

<a name="_showUsage_" class="fun-org"><span class=defExt>extern</span> extern void showUsage(int nCom)</a>

<a name="_scriptTips_" class="fun-org"><span class=defExt>extern</span> void scriptTips(int msg)</a>
/* msg: 0: no extern-tips, no wait; 1: no wait; >1 extern-tips & wait */

<a name="_HBinfo_" class="fun-org"><span class=defExt>extern</span> char *HBinfo(int idx, int isRoot)</a>

<a name="_GetUsage_" class="fun-org"><a class="cpp">#define</a> GetUsage(nmb)     HBinfo(nmb,0)

<a name="_GetHB_" class="fun-org"><a class="cpp">#define</a>  GetHB(idx)    HBinfo(idx,1)

<a name="_ORLinfo_" class="fun-org"><span class=defExt>extern</span> void ORLinfo(<span class=fspDir>__ORD</span> *dir, char *buf)</a>

<a name="_ORLhb_" class="fun-org"><span class=defExt>extern</span> void ORLhb(const int idx, const char *txt)</a>

<a name="_ORputas_" class="fun-org"><span class=defExt>extern</span> int ORputas(<span class=fspLib>__ORL</span> *lib, int space)</a>

<a name="_usedORL_" class="fun-org"><span class=defExt>extern</span> int usedORL(const char *fn, const char *inpPath)</a>

<a name="_extDest_" class="fun-org"><span class=defExt>extern</span> void (*extDest)(void *)</a>
use in void ORLreleas(<span class=fspLib>__ORL</span> *lib, void (*extDest)(void *p) )

<a name="_ORLuse_" class="fun-org"><span class=defExt>extern</span> <span class=fspLib>__ORL</span> *ORLuse(const char *filenam, OpenSpace msg, int n)</a>
/* n: -1 append workspace; -2 no workspace; >-1 is spe */

<a name="_ORLspac_" class="fun-org"><span class=defExt>extern</span> <span class=fspLib>__ORL</span> *ORLspac(const char *pth, OpenSpace msg, int n)</a>
/* n: -1 append workspace; -2 no workspace; >-1 is spe */

<a name="_ORLreleas_" class="fun-org"><span class=defExt>extern</span> void ORLreleas(<span class=fspLib>__ORL</span> *lib, void (*fun)(void *p) )</a>
void (*fun)(void *p)可以是空。

<a name="_readTo_" class="fun-org"><span class=defExt>extern</span> BOOL readTo(<span class=fspDir>__ORD</span> *dir, BYTE *unit, int Type, int cnt, FILE *fp)</a>

<a name="_ORLexpo_" class="fun-org"><span class=defExt>extern</span> void ORLexpo(<span class=fspLib>__ORL</span> *, int argc, char **argv, int type)</a>

<a name="_NumCopy_" class="fun-org"><span class=defExt>extern</span> void NumCopy(<span class=fspLib>__ORL</span> *,char **pms, const char *extparm)</a>

<a name="_ORDcopy_" class="fun-org"><span class=defExt>extern</span> void ORDcopy(<span class=fspLib>__ORL</span> *, int argc, char **argv, const char *extparm)</a>

<a name="_getSpace_" class="fun-org"><span class=defExt>extern</span> BOOL getSpace(const char *extparm,int *s,int *d)</a>

<a name="_selSpace_" class="fun-org"><span class=defExt>extern</span> int selSpace(int sel)</a>

<a name="_getPdPara_" class="fun-org"><span class=defExt>extern</span> void getPdPara(<span class=fspDir>__ORD</span> *dir, un_Int *lst)</a>

<a name="_fixpath_" class="fun-org"><span class=defExt>extern</span> char *fixpath(const char *pthnam, const char *tmp)</a>

<a name="_ORLrebuild_" class="fun-org"><span class=defExt>extern</span> <span class=fspLib>__ORL</span> *ORLrebuild(<span class=fspLib>__ORL</span> *send, const char *filenam, int msg)</a>
/* msg ShowTips or OptiFit */

<a name="_orfn_" class="fun-org"><span class=defExt>extern</span> const char *orfn(const char *fnam, const char *self, const char *inst, int *rt, const char **selfcwd)</a>

<a name="_init_" class="fun-org"><span class=defExt>extern</span> int init(int *argc, char **argv, const char *conStr/* fmt list */)</a>

<a name="_outTxt_" class="fun-org"><span class=defExt>extern</span> void outTxt(int x, int attr, const char *txt)</a>

<a name="_inCon_" class="fun-org"><span class=defExt>extern</span> int inCon(char *buf, int lmt)</a>

<a name="_setCfgVal_" class="fun-org"><span class=defExt>extern</span> void setCfgVal(char *pms)</a>

<a name="_comRun_" class="fun-org"><span class=defExt>extern</span> <span class=fspLib>__ORL</span> *comRun(<span class=fspLib>__ORL</span> *,char *inpbuf, int env, const char *pth)</a>
/* env => 0bit : append;  1bit : mkar, no info */

<a name="_ORDinfors_" class="fun-org"><span class=defExt>extern</span> void ORDinfors(<span class=fspDir>__ORD</span> *, char *buf, int s)</a>
/* s: 0 no show tip; 1 show tip; 2 with tip no show (only return OutBuf */

<a name="_ORLscript_" class="fun-org"><span class=defExt>extern</span> <span class=fspLib>__ORL</span> *ORLscript(<span class=fspLib>__ORL</span> *lib, char *txt, int msg, const char *pth)</a>

<a name="_isNumb_" class="fun-org"><span class=defExt>extern</span> int isNumb(const char *pt)</a>

<a name="_paraExpre_" class="fun-org"><span class=defExt>extern</span> int paraExpre(unsigned int val, char *buf, const char *fmt)</a>
// return buf len

</pre>
</body>
</html>