/*
	Write by xempo 2015
	Free under LGPL
*/

#include "options.h"

extern void *zalloc(unsigned int); // orkern.h

static int invObj(const ProcOpt *opt, int i, const char *pmu)
{
int B, C, D;
for(B=0; B<opt->inv_cnt; B++)if(i==opt->inv[B])
	for(C=0; C<opt->argc; C++)
		if(i!=C&&opt->rtval[C]){
			for(D=0; D<opt->inv_cnt; D++)
			    if(C==opt->inv[D]){
				char buf[1024];
				sprintf(buf, "\"%s\" can't use with \"%s\"\n", pmu, opt->rtval[C]&0x8000 ? opt->_argv[C] : opt->argv[C]);
				msgShow(buf);
				return -1;
				}
		}
return 0;
}

inline int propts(ProcOpt *opt , int argc, const char **argv, int *pmIdx)
{
 int i, a, pmc=0, tms;
 const char **pmu;
 for(tms=0, pmu=opt->argv; tms<2; tms++, pmu=opt->_argv)if(pmu)
   for(i=0; i<opt->argc; i++)
       for(a=0; a<argc; a++)if(strcmp(pmu[i], argv[a])==0){
	if(invObj(opt, i, pmu[i])==-1){
		opt->errno=1;
		return -1;
		}
	pmIdx[pmc++]=a;
	opt->rtval[i]=(a+1) | (tms*0x8000);
       }
return pmc;
}

const char *paraSepa;
inline int multcmp(const char *fmt, const char *dat)
{
int i=0;
while( fmt[i] && fmt[i]==dat[i] )i++;
if(fmt[i]==0){
        if(dat[i]==0)return 0;
        else if(strchr(paraSepa, dat[i]))return i;
}
return -1;
}

inline arglist *propts2(ProcOpt *opt , int argc, const char **argv, int *pmIdx, int *pmcmp)
{
 int i, a, tms, pmc=0, b=0, sw, n, j;
 char buf[1024];
 const char **pmu;
 static const char errTips[]="\"%s\" is keyword, can't follow \"%s\" !\n";
 arglist *alst=(arglist *)malloc(sizeof(arglist));
 alst->argv=(const char **)malloc(sizeof(char *)*(opt->argc));
 for(tms=0, pmu=opt->argv; tms<2; tms++, pmu=opt->_argv)if(pmu)
   for(i=0; i<opt->argc; i++)
       for(a=0; a<argc; a++)if( (sw=multcmp(pmu[i], argv[a]))!=-1 ){
	if(invObj(opt, i, pmu[i])==-1){
		opt->errno=1;
	_exit_:	free(alst->argv); free(alst);
		return NULL;
		}
	  pmIdx[b++]=a | (sw ? 0x8000 : 0);
	  pmc+= sw ? 1 : 2;
	  n=opt->rtval[i]&0x7fff;
	  alst->argv[i]=sw ? argv[a]+sw+1 : argv[a+1];
// ________________ wrongs ___________________
	  for(j=0; j<argc; j++){
	     if(a+1==pmcmp[j] && sw==0 ){
		sprintf(buf, errTips, argv[a+1], pmu[i]);
		opt->errno=2;
		msgShow(buf);
		goto _skp_;
		}
	     if( a+1>=argc && (sw==0||alst->argv[i][0]==0) )_skp_: {
		sprintf(buf, "\"%s\" lost followed object !\n", pmu[i]);
		opt->errno=3;
		msgShow(buf);
		if(n)break;
		else goto _exit_;
	     }
	     if(pmIdx[j]==a-1){
		sprintf(buf, errTips, pmu[i], argv[a-1]);
		msgShow(buf);
		opt->errno=4;
		if(n)break;
		else goto _exit_;
		}
	     if(a+1<argc && pmIdx[j]==a+1){
		sprintf(buf, errTips, argv[a+1], pmu[i]);
		msgShow(buf);
		opt->errno=5;
		if(n)break;
		else goto _exit_;
		}
	  } // end for
	  if(n){
		const char *cur, *old;
		int c;
		cur=sw ? argv[a] : catstr(argv[a], argv[a+1], 32);
		for(c=0; c<argc; c++)
			if( (pmIdx[c]&0x7fff)==n-1){
				old=(pmIdx[c]>0x7fff) ? argv[n-1] : catstr(argv[n-1], argv[n], 32);
				break;
			}
		sprintf(buf, "\"%s\" has specified, \"%s\" is wrong\n", old, cur);
		msgShow(buf);
		if(sw==0)free((void *)cur);
		if(pmIdx[c]<0x7fff)free((void *)old);
		goto _exit_;
	  }
// ________________end wrongs _________________
	  opt->rtval[i]=(a+1) | (tms*0x8000);
	}
 alst->argc=pmc;
 return alst;
}

inline void purestr(char *ptr)
{ // ought to in fmtvalue
//   "pure water" => pure water
//   \"pure water" => "pure water"
	int L=strlen(ptr);
	if(*ptr=='\\' ){
		if(L==1)return;
		memmove(ptr, ptr+1, L);
	}
	else if(*ptr=='\"'&&L>1&&ptr[L-1]=='\"'){
		ptr[L-1]=0;
		memmove(ptr, ptr+1, L-1);
	}
}

arglists *procParas(int argc, char **argv, ProcOpt *opt1, ProcOpt *opt2)
{
 int a, pmc, pmc2, operaCnt,
	pmIndex[argc], pm2Index[argc];
 arglist *sublst;
 for(a=0; a<argc; a++)pmIndex[a]=-2;
 for(a=0; a<argc; a++)pm2Index[a]=-2;
 if(opt1){
	if( (pmc=propts(opt1, argc, (const char **)argv, pmIndex))==-1)return NULL;
	}
 else pmc=0;
 if(opt2){
	if((sublst=propts2(opt2, argc, (const char **)argv, pm2Index, pmIndex))==NULL)return NULL;
	pmc2=sublst->argc;
	}
 else pmc2=0;
 operaCnt=argc-pmc-pmc2;
 arglists *lst=(arglists *)zalloc(sizeof(arglists));
 if(operaCnt){
	int  i, j, n=0;
	const char **operaObj=(const char **)malloc(operaCnt*sizeof(char *));
	for(a=0; a<argc; a++){
	    for(i=0; i<pmc && pmIndex[i]!=a; i++);
	    for(j=0; j<pmc2&&((pm2Index[j]&0x7fff)!=a&&(pm2Index[j]/*&0x7fff*/)!=a-1/* followed object */); j++);
	    if(i>=pmc&&j>=pmc2){
		purestr(argv[a]);
		operaObj[n++]=argv[a];
		}
	}
   lst->argc=operaCnt;	lst->argv=operaObj;
  }
   if(opt2)lst->subarg=sublst;
   return lst;
}

void unPara(arglists *alst, int i)
{
char buf[1024];
while( i<alst->argc ){
	sprintf(buf, "\"%s\" is unuseful !\n", alst->argv[i]);
	msgShow(buf);
	i++;
	}
}

void argsFree(arglists *lst)
{
if(lst->subarg){
	free((void *)lst->subarg->argv);
	free((void *)lst->subarg);
	}
if(lst->argc)free((void *)lst->argv);
free(lst);
}
