/*
	Write & edit by Linjianghua 2005-06,2008-2011
	Free under LGPL
*/

#include "dirloop.h"
#include "ordir.h"

const char SPC[]="";
int  _step;

int NumBrowth(__ORD *dir,int (*pro_numb)(__ORD *,BYTE *))
{
 int rt=1; // no numb is normal !
 __ORL *lib=dir->lib;
 if( dir->numb_FCT>0 ){
	BYTE *dsb;
	dir->NumbForZero=0;
	if(lib->sys_Id_done)lib->cur_sys_numb_FCT=lib->sys_numb_FCT;
	else dir->cur_numb_FCT=dir->numb_FCT;
	while((dsb=seekFCU(dir,0,NULL, NUMB_FCU_BLANK))!=NULL){
	   rt=pro_numb(dir,dsb);
	   free(dsb);
	   if(rt==0||dir->cur_numb_FCT<1)break;
	}
  }
  lib->sys_Id_done=False; /* only export & rebuild use it (True), so here set False*/
  return rt;
}

void setDFCU(__ORD *pdir, __ORD *dir, dskadr_t pos, unsigned int dirsiz)
{
	BYTE flag=_step > 0 ? 1 : 2;
	__ORL *lib=dir->lib;
	pdir->selfdirs+=_step; pdir->mdf|=1;
	lib->tolDir+=_step; lib->mdf|=1;
	if(_step>0){
		pdir->selfsize+=dir->savelen;
		lib->useSize+=(dirsiz + dir->savelen);
		}
	else {
		pdir->selfsize-=dir->savelen;
		lib->useSize-=(dirsiz + dir->savelen);
	}
	dkwrite(lib, pos, &flag, 1);
}

/* pro_numbs or pro_dirs depend on Msg
Msg: if pro_numb null, clear 0bit. */
int ORDbrowth(__ORD *pdir, int Msg, int (*pro_numb)(__ORD *,BYTE *),int (*pro_dir)(__ORD *,__ORD *))
{
  DirFCU *unit, *dsb;
  FCU_PAT *dirloop;
  int i, rt, msg;
  __ORD *dir2, *dirbuf;
  __ORL *lib;
  if((Msg&LoopNum)&&NumBrowth(pdir, pro_numb)==0)return 0;
  dirloop=dGetFCU(pdir);
  if(dirloop->first_FCT==0)return 1;
  dirloop->current_FCT=dirloop->first_FCT;
  rt=1; lib=pdir->lib;
  if(Msg&(LoopDir|LoopDirSub) )
    while( (rt&33) /* rt==1 || rt==32 */
	&&(dsb=ORDseek(pdir,(void *)SPC,DIR_FCU_BLANK))!=NULL){
	unit=dsb;
	for(i=0;i<dirloop->FCU_Count&&rt;i++,unit++)
	  switch(unit->tag){
	  case 2 : if(Msg&LoopForce)goto _skp_;
		    break;
	  case 1 : if((Msg&LoopForce)==0){
	    _skp_: dirbuf=ORDalloc(); /* perhans too dir-loop, so use heap */
	    dir2=ORDread(lib,dirbuf,unit,unit->pDir, False);
	    if(Msg&LoopDir)rt=pro_dir(pdir,dir2);/* if rt>1, can't proc its belong */
	    if( rt&(1|msg_Dir_Del) ){ // rt==1 || rt==msg_Dir_Del
	      msg=rt;
	      if(Msg&LoopDirSub)rt=ORDbrowth(dir2,Msg,pro_numb,pro_dir);
	      if( rt && msg==msg_Dir_Del/*(Msg&2)&&pro_dir==ProcDirFCU &&step<0*/)
		setDFCU(pdir, dir2, dir2->Own_FCU_Addr, dir2->selfsize);
	    }
	    if(dir2==dirbuf)ORDclose(dir2, 0);
	    else free(dirbuf);
	  }
	} // end switch
	free(dsb);
      }
return rt;
}

